(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["createResource"] = factory();
	else
		root["createResource"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.getStatus = exports.upsertManyResources = exports.upsertResource = exports.updateManyResourceMetas = exports.updateResourceMeta = exports.requestStatuses = exports.actionTypes = exports.resourceReducer = undefined;
	
	var _resourceReducer = __webpack_require__(1);
	
	var _resourceReducer2 = _interopRequireDefault(_resourceReducer);
	
	var _actionTypes = __webpack_require__(21);
	
	var _actionTypes2 = _interopRequireDefault(_actionTypes);
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	var _updateResourceMeta = __webpack_require__(9);
	
	var _updateResourceMeta2 = _interopRequireDefault(_updateResourceMeta);
	
	var _updateManyResourceMetas = __webpack_require__(15);
	
	var _updateManyResourceMetas2 = _interopRequireDefault(_updateManyResourceMetas);
	
	var _upsertResource = __webpack_require__(10);
	
	var _upsertResource2 = _interopRequireDefault(_upsertResource);
	
	var _upsertManyResources = __webpack_require__(16);
	
	var _upsertManyResources2 = _interopRequireDefault(_upsertManyResources);
	
	var _getStatus = __webpack_require__(22);
	
	var _getStatus2 = _interopRequireDefault(_getStatus);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	exports.resourceReducer = _resourceReducer2.default;
	exports.actionTypes = _actionTypes2.default;
	exports.requestStatuses = _requestStatuses2.default;
	exports.updateResourceMeta = _updateResourceMeta2.default;
	exports.updateManyResourceMetas = _updateManyResourceMetas2.default;
	exports.upsertResource = _upsertResource2.default;
	exports.upsertManyResources = _upsertManyResources2.default;
	exports.getStatus = _getStatus2.default;

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.default = resourceReducer;
	
	var _generateDefaultInitialState = __webpack_require__(2);
	
	var _generateDefaultInitialState2 = _interopRequireDefault(_generateDefaultInitialState);
	
	var _generateReducer = __webpack_require__(4);
	
	var _generateReducer2 = _interopRequireDefault(_generateReducer);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	// Create a resource reducer.
	//
	// `resourceName`: the plural name of your resource. For instance, "books".
	// `initialState`: additional initial state to include on this resource
	function resourceReducer(resourceName) {
	  var initialState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
	  var _options$plugins = options.plugins,
	      plugins = _options$plugins === undefined ? [] : _options$plugins;
	
	  var defaultInitialState = (0, _generateDefaultInitialState2.default)();
	  var initial = _extends({}, defaultInitialState, initialState, {
	    listMeta: _extends({}, defaultInitialState.listMeta, initialState.listMeta)
	  });
	
	  return (0, _generateReducer2.default)({
	    initialState: initial,
	    resourceName: resourceName,
	    plugins: plugins
	  });
	}
	module.exports = exports['default'];

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = generateDefaultInitialState;
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function generateDefaultInitialState() {
	  return {
	    // These are the actual resources that the server sends back.
	    resources: [],
	    // This is metadata about _specific_ resources. For instance, if a DELETE
	    // is in flight for a book with ID 24, then you could find that here.
	    meta: {},
	    // This is metadata about the entire collection of resources. For instance,
	    // on page load, you might fetch all of the resources. The XHR status for
	    // that request would live here.
	    listMeta: {
	      readStatus: _requestStatuses2.default.NULL,
	      createStatus: _requestStatuses2.default.NULL,
	      createManyStatus: _requestStatuses2.default.NULL
	    }
	  };
	}
	module.exports = exports['default'];

/***/ },
/* 3 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	// These are statuses for in-flight requests. If a request has no status
	// associated with it, then it would have a status of `NULL`.
	exports.default = {
	  PENDING: 'PENDING',
	  SUCCEEDED: 'SUCCEEDED',
	  FAILED: 'FAILED',
	  NULL: 'NULL'
	};
	module.exports = exports['default'];

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = generateReducers;
	
	var _actionReducers = __webpack_require__(5);
	
	var _actionReducers2 = _interopRequireDefault(_actionReducers);
	
	var _composeReducers = __webpack_require__(20);
	
	var _composeReducers2 = _interopRequireDefault(_composeReducers);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function generateReducers(options) {
	  var initialState = options.initialState,
	      resourceName = options.resourceName,
	      plugins = options.plugins;
	
	
	  return function reducer() {
	    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
	    var action = arguments[1];
	
	    var actionReducer = _actionReducers2.default[action.type];
	    if (action.resourceName !== resourceName) {
	      return state;
	    }
	
	    // Compute the state from the built-in reducers
	    var defaultResult = actionReducer ? actionReducer(state, action) : state;
	    // Compute the state from any additional reducer plugins
	    var customResult = (0, _composeReducers2.default)(plugins)(defaultResult, action);
	
	    return customResult ? customResult : state;
	  };
	}
	module.exports = exports['default'];

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _reducers = __webpack_require__(6);
	
	var reducers = _interopRequireWildcard(_reducers);
	
	function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }
	
	exports.default = {
	  CREATE_RESOURCE: reducers.create,
	  CREATE_RESOURCE_FAIL: reducers.createFail,
	  CREATE_RESOURCE_SUCCEED: reducers.createSucceed,
	  CREATE_RESOURCE_RESET: reducers.createReset,
	
	  READ_RESOURCE: reducers.read,
	  READ_RESOURCE_FAIL: reducers.readFail,
	  READ_RESOURCE_SUCCEED: reducers.readSucceed,
	  READ_RESOURCE_RESET: reducers.readReset,
	
	  UPDATE_RESOURCE: reducers.update,
	  UPDATE_RESOURCE_FAIL: reducers.updateFail,
	  UPDATE_RESOURCE_SUCCEED: reducers.updateSucceed,
	  UPDATE_RESOURCE_RESET: reducers.updateReset,
	
	  DELETE_RESOURCE: reducers.del,
	  DELETE_RESOURCE_FAIL: reducers.delFail,
	  DELETE_RESOURCE_SUCCEED: reducers.delSucceed,
	  DELETE_RESOURCE_RESET: reducers.delReset,
	
	  CREATE_MANY_RESOURCES: reducers.createMany,
	  CREATE_MANY_RESOURCES_FAIL: reducers.createManyFail,
	  CREATE_MANY_RESOURCES_SUCCEED: reducers.createManySucceed,
	  CREATE_MANY_RESOURCES_RESET: reducers.createManyReset,
	
	  READ_MANY_RESOURCES: reducers.readMany,
	  READ_MANY_RESOURCES_FAIL: reducers.readManyFail,
	  READ_MANY_RESOURCES_SUCCEED: reducers.readManySucceed,
	  READ_MANY_RESOURCES_RESET: reducers.readManyReset,
	
	  UPDATE_MANY_RESOURCES: reducers.updateMany,
	  UPDATE_MANY_RESOURCES_FAIL: reducers.updateManyFail,
	  UPDATE_MANY_RESOURCES_SUCCEED: reducers.updateManySucceed,
	  UPDATE_MANY_RESOURCES_RESET: reducers.updateManyReset,
	
	  DELETE_MANY_RESOURCES: reducers.delMany,
	  DELETE_MANY_RESOURCES_FAIL: reducers.delManyFail,
	  DELETE_MANY_RESOURCES_SUCCEED: reducers.delManySucceed,
	  DELETE_MANY_RESOURCES_RESET: reducers.delManyReset
	};
	module.exports = exports['default'];

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _create = __webpack_require__(7);
	
	Object.keys(_create).forEach(function (key) {
	  if (key === "default" || key === "__esModule") return;
	  Object.defineProperty(exports, key, {
	    enumerable: true,
	    get: function get() {
	      return _create[key];
	    }
	  });
	});
	
	var _read = __webpack_require__(11);
	
	Object.keys(_read).forEach(function (key) {
	  if (key === "default" || key === "__esModule") return;
	  Object.defineProperty(exports, key, {
	    enumerable: true,
	    get: function get() {
	      return _read[key];
	    }
	  });
	});
	
	var _update = __webpack_require__(12);
	
	Object.keys(_update).forEach(function (key) {
	  if (key === "default" || key === "__esModule") return;
	  Object.defineProperty(exports, key, {
	    enumerable: true,
	    get: function get() {
	      return _update[key];
	    }
	  });
	});
	
	var _delete = __webpack_require__(13);
	
	Object.keys(_delete).forEach(function (key) {
	  if (key === "default" || key === "__esModule") return;
	  Object.defineProperty(exports, key, {
	    enumerable: true,
	    get: function get() {
	      return _delete[key];
	    }
	  });
	});
	
	var _createMany = __webpack_require__(14);
	
	Object.keys(_createMany).forEach(function (key) {
	  if (key === "default" || key === "__esModule") return;
	  Object.defineProperty(exports, key, {
	    enumerable: true,
	    get: function get() {
	      return _createMany[key];
	    }
	  });
	});
	
	var _readMany = __webpack_require__(17);
	
	Object.keys(_readMany).forEach(function (key) {
	  if (key === "default" || key === "__esModule") return;
	  Object.defineProperty(exports, key, {
	    enumerable: true,
	    get: function get() {
	      return _readMany[key];
	    }
	  });
	});
	
	var _updateMany = __webpack_require__(18);
	
	Object.keys(_updateMany).forEach(function (key) {
	  if (key === "default" || key === "__esModule") return;
	  Object.defineProperty(exports, key, {
	    enumerable: true,
	    get: function get() {
	      return _updateMany[key];
	    }
	  });
	});
	
	var _deleteMany = __webpack_require__(19);
	
	Object.keys(_deleteMany).forEach(function (key) {
	  if (key === "default" || key === "__esModule") return;
	  Object.defineProperty(exports, key, {
	    enumerable: true,
	    get: function get() {
	      return _deleteMany[key];
	    }
	  });
	});

/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.create = create;
	exports.createFail = createFail;
	exports.createSucceed = createSucceed;
	exports.createReset = createReset;
	
	var _initialResourceMetaState = __webpack_require__(8);
	
	var _initialResourceMetaState2 = _interopRequireDefault(_initialResourceMetaState);
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	var _updateResourceMeta = __webpack_require__(9);
	
	var _updateResourceMeta2 = _interopRequireDefault(_updateResourceMeta);
	
	var _upsertResource = __webpack_require__(10);
	
	var _upsertResource2 = _interopRequireDefault(_upsertResource);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function create(state) {
	  return _extends({}, state, {
	    listMeta: _extends({}, state.listMeta, {
	      createStatus: _requestStatuses2.default.PENDING
	    })
	  });
	}
	
	function createFail(state) {
	  return _extends({}, state, {
	    listMeta: _extends({}, state.listMeta, {
	      createStatus: _requestStatuses2.default.FAILED
	    })
	  });
	}
	
	function createSucceed(state, action) {
	  var newResourceId = action.resource.id;
	  var resources = (0, _upsertResource2.default)({
	    resources: state.resources,
	    resource: action.resource,
	    id: action.id
	  });
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: _initialResourceMetaState2.default,
	    id: newResourceId,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    resources: resources,
	    meta: meta,
	    listMeta: _extends({}, state.listMeta, {
	      createStatus: _requestStatuses2.default.SUCCEEDED
	    })
	  });
	}
	
	function createReset(state) {
	  return _extends({}, state, {
	    listMeta: _extends({}, state.listMeta, {
	      createStatus: _requestStatuses2.default.NULL
	    })
	  });
	}

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	exports.default = {
	  // The status of any existing request to update this resource
	  updateStatus: _requestStatuses2.default.NULL,
	  // The status of any existing request to fetch this resource
	  readStatus: _requestStatuses2.default.NULL,
	  // The status of an any existing request to delete this resource. Note that
	  // this will never be "SUCCEEDED," as a successful delete removes the
	  // resource from the store.
	  deleteStatus: _requestStatuses2.default.NULL
	};
	module.exports = exports['default'];

/***/ },
/* 9 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.default = updateResourceMeta;
	
	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
	
	// Updates a single resource's metadata
	function updateResourceMeta(_ref) {
	  var meta = _ref.meta,
	      newMeta = _ref.newMeta,
	      id = _ref.id,
	      replace = _ref.replace;
	
	  var existingMeta = replace ? {} : meta[id];
	  return _extends({}, meta, _defineProperty({}, id, _extends({}, existingMeta, newMeta)));
	}
	module.exports = exports["default"];

/***/ },
/* 10 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.default = upsertResource;
	// Insert a new resource or update an existing resource.
	function upsertResource(_ref) {
	  var resources = _ref.resources,
	      resource = _ref.resource,
	      id = _ref.id,
	      replace = _ref.replace;
	
	  // Attempt to find the resource by its ID. If the ID doesn't exist, or if
	  // no resource by that ID exists, then we append it to the end as a new
	  // resource.
	  var resourceIndex = id && resources.findIndex(function (item) {
	    return item.id === id;
	  });
	  var shallowClone = Array.prototype.slice.call(resources);
	  if (!id || resourceIndex === -1) {
	    shallowClone.push(resource);
	    return shallowClone;
	  }
	
	  var resourceToInsert = void 0;
	  if (!replace) {
	    var currentResource = shallowClone[resourceIndex];
	    resourceToInsert = _extends({}, currentResource, resource);
	  } else {
	    resourceToInsert = resource;
	  }
	
	  // Otherwise, it does exist and we add it to the list at the appropriate
	  // location
	  shallowClone.splice(resourceIndex, 1, resourceToInsert);
	  return shallowClone;
	}
	module.exports = exports["default"];

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.read = read;
	exports.readFail = readFail;
	exports.readSucceed = readSucceed;
	exports.readReset = readReset;
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	var _updateResourceMeta = __webpack_require__(9);
	
	var _updateResourceMeta2 = _interopRequireDefault(_updateResourceMeta);
	
	var _upsertResource = __webpack_require__(10);
	
	var _upsertResource2 = _interopRequireDefault(_upsertResource);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function read(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { readStatus: _requestStatuses2.default.PENDING },
	    id: action.id,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function readFail(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { readStatus: _requestStatuses2.default.FAILED },
	    id: action.id,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function readSucceed(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { readStatus: _requestStatuses2.default.SUCCEEDED },
	    id: action.id,
	    replace: false
	  });
	
	  var replace = typeof action.replace !== 'undefined' ? action.replace : true;
	  var resources = (0, _upsertResource2.default)({
	    resources: state.resources,
	    resource: action.resource,
	    id: action.id,
	    replace: replace
	  });
	
	  return _extends({}, state, {
	    meta: meta,
	    resources: resources
	  });
	}
	
	function readReset(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { readStatus: _requestStatuses2.default.NULL },
	    id: action.id,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.update = update;
	exports.updateFail = updateFail;
	exports.updateSucceed = updateSucceed;
	exports.updateReset = updateReset;
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	var _updateResourceMeta = __webpack_require__(9);
	
	var _updateResourceMeta2 = _interopRequireDefault(_updateResourceMeta);
	
	var _upsertResource = __webpack_require__(10);
	
	var _upsertResource2 = _interopRequireDefault(_upsertResource);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function update(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { updateStatus: _requestStatuses2.default.PENDING },
	    id: action.id,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function updateFail(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { updateStatus: _requestStatuses2.default.FAILED },
	    id: action.id,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function updateSucceed(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { updateStatus: _requestStatuses2.default.SUCCEEDED },
	    id: action.id,
	    replace: false
	  });
	
	  var replace = typeof action.replace !== 'undefined' ? action.replace : true;
	  var resources = (0, _upsertResource2.default)({
	    resources: state.resources,
	    resource: action.resource,
	    id: action.id,
	    replace: replace
	  });
	
	  return _extends({}, state, {
	    meta: meta,
	    resources: resources
	  });
	}
	
	function updateReset(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { updateStatus: _requestStatuses2.default.NULL },
	    id: action.id,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.del = del;
	exports.delFail = delFail;
	exports.delSucceed = delSucceed;
	exports.delReset = delReset;
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	var _updateResourceMeta = __webpack_require__(9);
	
	var _updateResourceMeta2 = _interopRequireDefault(_updateResourceMeta);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
	
	function del(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { deleteStatus: _requestStatuses2.default.PENDING },
	    id: action.id,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function delFail(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { deleteStatus: _requestStatuses2.default.FAILED },
	    id: action.id,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function delSucceed(state, action) {
	  var id = action.id;
	
	  // Remove this resource from the resources meta.
	  var meta = _extends({}, state.meta, _defineProperty({}, id, null));
	
	  // Shallow clone the existing resource array, removing the deleted resource
	  var resources = state.resources.filter(function (r) {
	    return r.id !== id;
	  });
	
	  return _extends({}, state, {
	    meta: meta,
	    resources: resources
	  });
	}
	
	function delReset(state, action) {
	  var meta = (0, _updateResourceMeta2.default)({
	    meta: state.meta,
	    newMeta: { deleteStatus: _requestStatuses2.default.NULL },
	    id: action.id,
	    replace: false
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.createMany = createMany;
	exports.createManyFail = createManyFail;
	exports.createManySucceed = createManySucceed;
	exports.createManyReset = createManyReset;
	
	var _initialResourceMetaState = __webpack_require__(8);
	
	var _initialResourceMetaState2 = _interopRequireDefault(_initialResourceMetaState);
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	var _updateManyResourceMetas = __webpack_require__(15);
	
	var _updateManyResourceMetas2 = _interopRequireDefault(_updateManyResourceMetas);
	
	var _upsertManyResources = __webpack_require__(16);
	
	var _upsertManyResources2 = _interopRequireDefault(_upsertManyResources);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function createMany(state) {
	  return _extends({}, state, {
	    listMeta: _extends({}, state.listMeta, {
	      createManyStatus: _requestStatuses2.default.PENDING
	    })
	  });
	}
	
	function createManyFail(state) {
	  return _extends({}, state, {
	    listMeta: _extends({}, state.listMeta, {
	      createManyStatus: _requestStatuses2.default.FAILED
	    })
	  });
	}
	
	function createManySucceed(state, action) {
	  var resources = action.resources;
	  var ids = resources.map(function (r) {
	    return r.id;
	  });
	
	  var newResources = (0, _upsertManyResources2.default)({
	    resources: state.resources,
	    replace: false,
	    newResources: resources
	  });
	
	  return _extends({}, state, {
	    resources: newResources,
	    // We have new resources, so we need to update their meta state with the
	    // initial meta state.
	    meta: (0, _updateManyResourceMetas2.default)({
	      meta: state.meta,
	      replace: false,
	      newMeta: _initialResourceMetaState2.default,
	      ids: ids
	    }),
	    listMeta: _extends({}, state.listMeta, {
	      createManyStatus: _requestStatuses2.default.SUCCEEDED
	    })
	  });
	}
	
	function createManyReset(state) {
	  return _extends({}, state, {
	    listMeta: _extends({}, state.listMeta, {
	      createManyStatus: _requestStatuses2.default.NULL
	    })
	  });
	}

/***/ },
/* 15 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.default = updateManyResourceMetas;
	// Similar to `updateResourceMeta`, but it accepts an array of IDs instead of
	// a single ID. Used for bulk updating meta.
	function updateManyResourceMetas(_ref) {
	  var meta = _ref.meta,
	      newMeta = _ref.newMeta,
	      ids = _ref.ids,
	      replace = _ref.replace;
	
	  var next = replace ? {} : _extends({}, meta);
	
	  ids.forEach(function (id) {
	    var current = next[id];
	    next[id] = _extends({}, current, newMeta);
	  });
	
	  return next;
	}
	module.exports = exports["default"];

/***/ },
/* 16 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.default = upsertManyResources;
	// Similar to `upsertResource`, but for many resources.
	function upsertManyResources(_ref) {
	  var resources = _ref.resources,
	      newResources = _ref.newResources,
	      replace = _ref.replace;
	
	  var shallowClone = replace ? [] : Array.prototype.slice.call(resources);
	
	  newResources.forEach(function (resource) {
	    var id = resource.id;
	    var resourceIndex = id && resources.findIndex(function (item) {
	      return item.id === id;
	    });
	
	    if (!id || resourceIndex === -1) {
	      return shallowClone.push(resource);
	    }
	
	    var resourceToInsert = void 0;
	    if (!replace) {
	      var currentResource = shallowClone[resourceIndex];
	      resourceToInsert = _extends({}, currentResource, resource);
	    } else {
	      resourceToInsert = resource;
	    }
	
	    shallowClone.splice(resourceIndex, 1, resourceToInsert);
	  });
	
	  return shallowClone;
	}
	module.exports = exports["default"];

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.readMany = readMany;
	exports.readManyFail = readManyFail;
	exports.readManySucceed = readManySucceed;
	exports.readManyReset = readManyReset;
	
	var _initialResourceMetaState = __webpack_require__(8);
	
	var _initialResourceMetaState2 = _interopRequireDefault(_initialResourceMetaState);
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	var _updateManyResourceMetas = __webpack_require__(15);
	
	var _updateManyResourceMetas2 = _interopRequireDefault(_updateManyResourceMetas);
	
	var _upsertManyResources = __webpack_require__(16);
	
	var _upsertManyResources2 = _interopRequireDefault(_upsertManyResources);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function readMany(state) {
	  return _extends({}, state, {
	    listMeta: _extends({}, state.listMeta, {
	      readStatus: _requestStatuses2.default.PENDING
	    })
	  });
	}
	
	function readManyFail(state) {
	  return _extends({}, state, {
	    listMeta: _extends({}, state.listMeta, {
	      readStatus: _requestStatuses2.default.FAILED
	    })
	  });
	}
	
	function readManySucceed(state, action) {
	  var resources = action.resources;
	  var ids = resources.map(function (r) {
	    return r.id;
	  });
	  var replace = typeof action.replace !== 'undefined' ? action.replace : true;
	
	  var newResources = void 0;
	  if (!replace) {
	    newResources = (0, _upsertManyResources2.default)({
	      resources: state.resources,
	      replace: false,
	      newResources: resources
	    });
	  } else {
	    newResources = resources;
	  }
	
	  return _extends({}, state, {
	    resources: newResources,
	    // We have new resources, so we need to update their meta state with the
	    // initial meta state.
	    meta: (0, _updateManyResourceMetas2.default)({
	      meta: state.meta,
	      newMeta: _initialResourceMetaState2.default,
	      ids: ids, replace: replace
	    }),
	    listMeta: _extends({}, state.listMeta, {
	      readStatus: _requestStatuses2.default.SUCCEEDED
	    })
	  });
	}
	
	function readManyReset(state) {
	  return _extends({}, state, {
	    listMeta: _extends({}, state.listMeta, {
	      readStatus: _requestStatuses2.default.NULL
	    })
	  });
	}

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.updateMany = updateMany;
	exports.updateManyFail = updateManyFail;
	exports.updateManySucceed = updateManySucceed;
	exports.updateManyReset = updateManyReset;
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	var _updateManyResourceMetas = __webpack_require__(15);
	
	var _updateManyResourceMetas2 = _interopRequireDefault(_updateManyResourceMetas);
	
	var _upsertManyResources = __webpack_require__(16);
	
	var _upsertManyResources2 = _interopRequireDefault(_upsertManyResources);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function updateMany(state, action) {
	  var resources = action.resources;
	  var ids = resources.map(function (r) {
	    return r.id;
	  });
	
	  var meta = (0, _updateManyResourceMetas2.default)({
	    meta: state.meta,
	    newMeta: { updateStatus: _requestStatuses2.default.PENDING },
	    replace: false,
	    ids: ids
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function updateManyFail(state, action) {
	  var resources = action.resources;
	  var ids = resources.map(function (r) {
	    return r.id;
	  });
	
	  var meta = (0, _updateManyResourceMetas2.default)({
	    meta: state.meta,
	    newMeta: { updateStatus: _requestStatuses2.default.FAILED },
	    replace: false,
	    ids: ids
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function updateManySucceed(state, action) {
	  var resources = action.resources;
	  var ids = resources.map(function (r) {
	    return r.id;
	  });
	
	  var meta = (0, _updateManyResourceMetas2.default)({
	    meta: state.meta,
	    newMeta: { updateStatus: _requestStatuses2.default.SUCCEEDED },
	    replace: false,
	    ids: ids
	  });
	
	  var replace = typeof action.replace !== 'undefined' ? action.replace : false;
	  var newResources = (0, _upsertManyResources2.default)({
	    resources: state.resources,
	    newResources: resources,
	    replace: replace
	  });
	
	  return _extends({}, state, {
	    resources: newResources,
	    meta: meta
	  });
	}
	
	function updateManyReset(state, action) {
	  var resources = action.resources;
	  var ids = resources.map(function (r) {
	    return r.id;
	  });
	
	  var meta = (0, _updateManyResourceMetas2.default)({
	    meta: state.meta,
	    newMeta: { updateStatus: _requestStatuses2.default.NULL },
	    replace: false,
	    ids: ids
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}

/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	exports.delMany = delMany;
	exports.delManyFail = delManyFail;
	exports.delManySucceed = delManySucceed;
	exports.delManyReset = delManyReset;
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	var _updateManyResourceMetas = __webpack_require__(15);
	
	var _updateManyResourceMetas2 = _interopRequireDefault(_updateManyResourceMetas);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function delMany(state, action) {
	  var ids = action.ids;
	
	  var meta = (0, _updateManyResourceMetas2.default)({
	    meta: state.meta,
	    newMeta: { deleteStatus: _requestStatuses2.default.PENDING },
	    replace: false,
	    ids: ids
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function delManyFail(state, action) {
	  var ids = action.ids;
	
	  var meta = (0, _updateManyResourceMetas2.default)({
	    meta: state.meta,
	    newMeta: { deleteStatus: _requestStatuses2.default.FAILED },
	    replace: false,
	    ids: ids
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}
	
	function delManySucceed(state, action) {
	  var ids = action.ids;
	
	  var newMeta = ids.reduce(function (memo, id) {
	    memo[id] = null;
	    return memo;
	  }, {});
	
	  // Remove this resource from the resources meta.
	  var meta = _extends({}, state.meta, newMeta);
	
	  // Shallow clone the existing resource array, removing the deleted resource
	  var newResources = state.resources.filter(function (r) {
	    return !ids.includes(r.id);
	  });
	
	  return _extends({}, state, {
	    resources: newResources,
	    meta: meta
	  });
	}
	
	function delManyReset(state, action) {
	  var ids = action.ids;
	
	  var meta = (0, _updateManyResourceMetas2.default)({
	    meta: state.meta,
	    newMeta: { deleteStatus: _requestStatuses2.default.NULL },
	    replace: false,
	    ids: ids
	  });
	
	  return _extends({}, state, {
	    meta: meta
	  });
	}

/***/ },
/* 20 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = composeReducers;
	function composeReducers(reducers) {
	  return function (state, action) {
	    return reducers.reduce(function (prevState, reducer) {
	      return reducer(prevState, action);
	    }, state);
	  };
	}
	module.exports = exports["default"];

/***/ },
/* 21 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
	
	// This function generates the five statuses from a single CRUD action.
	// For instance, you'd probably pass "CREATE", "READ", "UPDATE", or "DELETE"
	// as `crudAction`.
	var mapConstant = function mapConstant(resourceName, crudAction) {
	  var _ref;
	
	  return _ref = {}, _defineProperty(_ref, crudAction + '_' + resourceName, crudAction + '_' + resourceName), _defineProperty(_ref, crudAction + '_' + resourceName + '_SUCCEED', crudAction + '_' + resourceName + '_SUCCEED'), _defineProperty(_ref, crudAction + '_' + resourceName + '_FAIL', crudAction + '_' + resourceName + '_FAIL'), _defineProperty(_ref, crudAction + '_' + resourceName + '_RESET', crudAction + '_' + resourceName + '_RESET'), _ref;
	};
	
	var createTypes = mapConstant('RESOURCE', 'CREATE');
	var readTypes = mapConstant('RESOURCE', 'READ');
	var updateTypes = mapConstant('RESOURCE', 'UPDATE');
	var deleteTypes = mapConstant('RESOURCE', 'DELETE');
	var createManyTypes = mapConstant('RESOURCES', 'CREATE_MANY');
	var readManyTypes = mapConstant('RESOURCES', 'READ_MANY');
	var updateManyTypes = mapConstant('RESOURCES', 'UPDATE_MANY');
	var deleteManyTypes = mapConstant('RESOURCES', 'DELETE_MANY');
	
	exports.default = _extends({}, createTypes, readTypes, updateTypes, deleteTypes, createManyTypes, readManyTypes, updateManyTypes, deleteManyTypes);
	module.exports = exports['default'];

/***/ },
/* 22 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = getStatus;
	
	var _findMeta = __webpack_require__(23);
	
	var _findMeta2 = _interopRequireDefault(_findMeta);
	
	var _initialResourceMetaState = __webpack_require__(8);
	
	var _initialResourceMetaState2 = _interopRequireDefault(_initialResourceMetaState);
	
	var _requestStatuses = __webpack_require__(3);
	
	var _requestStatuses2 = _interopRequireDefault(_requestStatuses);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function getSingleStatus(state, action, metaLocation, isNullPending) {
	  var meta = (0, _findMeta2.default)(state, metaLocation);
	  if (!Object.keys(meta).length) {
	    meta = _initialResourceMetaState2.default;
	  }
	  var status = meta[action + 'Status'];
	
	  var isPending = status === _requestStatuses2.default.PENDING;
	  var nullPending = Boolean(isNullPending) && status === _requestStatuses2.default.NULL;
	
	  return {
	    pending: isPending || nullPending,
	    failed: status === _requestStatuses2.default.FAILED,
	    succeeded: status === _requestStatuses2.default.SUCCEEDED
	  };
	}
	
	// Returns the status of a particular CRUD action based on `metaLocation`.
	//
	// `state`: A piece of the Redux store containing the relevant resources
	// `action`: The CRUD action in question
	// `metaLocation`: A location of the meta resource (see `find-meta.js` for more)
	// `isNullPending`: Whether or not to count a status of `NULL` as pending.
	//
	// Returns an Object with the following properties:
	//
	// {
	//   failed: false,
	//   pending: false,
	//   succeeded: true,
	// }
	//
	// Note that at most _one_ of those properties will be true. It is
	// possible for them to all be false.
	function getStatus(state, action, metaLocations, isNullPending) {
	  if (!(metaLocations instanceof Array)) {
	    return getSingleStatus(state, action, metaLocations, isNullPending);
	  }
	
	  var statusValues = metaLocations.map(function (loc) {
	    return getSingleStatus(state, action, loc, isNullPending);
	  });
	
	  var pending = false;
	  var failed = false;
	  var succeeded = false;
	
	  var successCount = 0;
	  var pendingCount = 0;
	  for (var i = 0; i < statusValues.length; i++) {
	    var status = statusValues[i];
	    if (status.failed) {
	      failed = true;
	      break;
	    } else if (status.pending) {
	      pendingCount++;
	    } else if (status.succeeded) {
	      successCount++;
	    }
	  }
	
	  if (!failed && pendingCount > 0) {
	    pending = true;
	  } else if (successCount === statusValues.length) {
	    succeeded = true;
	  }
	
	  return { pending: pending, failed: failed, succeeded: succeeded };
	}
	module.exports = exports['default'];

/***/ },
/* 23 */
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = findMeta;
	// Returns the meta object from `state` based on `metaLocation`.
	// `metaLocation` describes where the meta is located. It can either be a string
	// or an object.
	// For instance,
	//
	// 'books' => returns the list meta for books
	// 'books.42' => returns the resource meta for the book with ID 42
	//
	// Alternatively, you can specify an object for `metaLocation`:
	//
	// { resourceName: 'books' }
	// { resourceName: 'books', id: 42 }
	//
	function findMeta(state, metaLocation) {
	  var resourceName = void 0,
	      resourceId = void 0;
	
	  if (typeof metaLocation === 'string') {
	    var splitPath = metaLocation.split('.');
	    resourceName = splitPath[0];
	    resourceId = splitPath[1];
	  } else {
	    resourceName = metaLocation.resourceName;
	    resourceId = metaLocation.id;
	  }
	
	  if (!resourceName) {
	    throw new Error('A resourceName is required.');
	  }
	
	  if (!resourceId) {
	    return state[resourceName].listMeta;
	  } else {
	    return state[resourceName].meta[resourceId] || {};
	  }
	}
	module.exports = exports['default'];

/***/ }
/******/ ])
});
;
//# sourceMappingURL=redux-simple-resource.js.map